#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "structure.h"
//#include "structure-ini.h"
#include "util.h"
#include "harv.h"

#define IN -99998

extern const char *REFINE_ID[];
extern PDBX_CRYSTAL_ALIGNMENT pdbx_crystal_alignment;
extern EXPTL_CRYSTAL exptl_crystal;
extern EXPTL_CRYSTAL_GROW exptl_crystal_grow;
extern PDBX_REFINE pdbx_refine;
extern CELL cell ;
extern SYMMETRY symmetry;
extern REFINE_HIST refine_hist;
extern COMPUTING computing;
extern PDBX_PHASING_DM  pdbx_phasing_dm;
extern PDBX_PHASING_DM_SHELL  pdbx_phasing_dm_shell;
extern PDBX_PHASING_MR  pdbx_phasing_MR;
extern PDBX_VALIDATE_OVERALL pdbx_validate_overall;
extern PHASING_MAD phasing_mad;
extern PHASING_MIR_SHELL phasing_mir_shell;
extern AXIS axis;
extern char REF_DETAIL[90000], REF_MODEL[900];

extern DIFFRN_RADIATION_WAVELENGTH diffrn_radiation_wavelength;
extern DIFFRN_RADIATION_WAVELENGTH diffrn_radiation_wavelength_neut;
extern EXPTL exptl;
extern EXPTL exptl_neut;
extern DIFFRN diffrn;
extern DIFFRN diffrn_neut;
extern DIFFRN_SOURCE diffrn_source;
extern DIFFRN_SOURCE diffrn_source_neut;
extern DIFFRN_DETECTOR diffrn_detector;
extern DIFFRN_DETECTOR diffrn_detector_neut;
extern DIFFRN_RADIATION diffrn_radiation_neut;
extern DIFFRN_RADIATION diffrn_radiation;
extern REFINE_LS_SHELL refine_ls_shell;
extern REFINE_LS_SHELL refine_shell_neut;
extern REFLNS_SHELL reflns_shell ;
extern REFLNS_SHELL reflns_shell_neut;
extern REFLNS  reflns ;
extern REFLNS  reflns_neut ;
extern REFINE refine;
extern REFINE refine_neutron;
extern REFINE_ANALYZE refine_analyze;
extern REFINE_ANALYZE refine_analyze_neut;


void write_exptl_crystal_grow(FILE *fout);
void write_refine_hist(FILE *fout);
void write_reflns_shell_run(FILE *fout, REFLNS_SHELL reflns_shell);
void write_refine_ls_shell_run(FILE *fout, REFINE_LS_SHELL refine_ls_shell);
void write_refine_run(FILE *fout, REFINE refine);
void write_diffrn_source(FILE *fout);
void write_diffrn_source_run(FILE *fout,DIFFRN_SOURCE diffrn_source);
void write_diffrn_detector(FILE *fout);
void write_diffrn_detector_run(FILE *fout, DIFFRN_DETECTOR diffrn_detector);
void write_diffrn_radiation(FILE *fout);
void write_diffrn_radiation_run(FILE *fout, DIFFRN_RADIATION diffrn_radiation);
void write_reflns(FILE *fout);
void write_reflns_run(FILE *fout, REFLNS reflns);
void write_diffrn(FILE *fout);
void write_diffrn_run(FILE *fout, DIFFRN diffrn);
void write_diffrn_radiation_wavelength(FILE *fout);
void write_pdbx_refine(FILE *fout);

// ####################################################################
void write_mmcif(FILE *fout, int argc, char **argv)
//  
{
    char method[80];
    int i,  scl_s=0,  ref=0,  dm=0, mr=0, index=0;
    
    for(i=1; i<argc; i++){
        if(!strcmp_case(argv[i], "-i")){
            index=1; // index=1
        
        }else if (!strcmp_case(argv[i], "-s")) {
            scl_s=1;
            if (strstr_case(argv[i+1],"xscale")){//No low resolution from log of xscale!
                reflns.d_resolution_low = refine.ls_d_res_low ;
                reflns_shell.d_res_low[0] = refine.ls_d_res_low ;
            }
//        else if (!strcmp_case(argv[i], "-sp")) scl_p=1; //skip right now
        }else if (!strcmp_case(argv[i], "-d")) dm=1;
        else if (!strcmp_case(argv[i], "-m")) mr=1;
        else if (!strcmp_case(argv[i], "-r")) ref=1;
        else if (!strcmp_case(argv[i], "-e")) strcpy(method,argv[i+1]) ;
    }
    
    if(refine_neutron.ls_d_res_high>0 && refine.ls_d_res_high>0)  {
        fprintf(fout,"#\nloop_ \n_exptl.entry_id \n_exptl.method \n_exptl.crystals_number \n");
        fprintf(fout,"%s  'X-RAY DIFFRACTION' %d \n ", DATA_BLOCK, exptl.crystals_number);
        fprintf(fout,"%s  'NEUTRON DIFFRACTION' %d \n ", DATA_BLOCK, exptl.crystals_number);
        
    }else if (refine_neutron.ls_d_res_high<0 && refine.ls_d_res_high>0){
        fprintf(fout,"#\n");
        fprintf(fout,"\n_exptl.crystals_number  %d\n", exptl.crystals_number);
        fprintf(fout,"_exptl.entry_id   %s\n", DATA_BLOCK);
        fprintf(fout,"_exptl.method   '%s'\n", exptl.method);
        
    }else if (refine_neutron.ls_d_res_high>0 && refine.ls_d_res_high<0){
        fprintf(fout,"#\n");
        fprintf(fout,"\n_exptl.crystals_number  %d\n", exptl_neut.crystals_number);
        fprintf(fout,"_exptl.entry_id   %s\n", DATA_BLOCK);
        fprintf(fout,"_exptl.method   '%s'\n", exptl_neut.method);
    }
    
/*    
    a1=pdbx_validate_overall.clashscore;
    a2=pdbx_validate_overall.ramachandran_outlier_percent;
    a3=pdbx_validate_overall.ramachandran_favored_percent;
    if(a1>0 || a2>0 || a3>0){
        fprintf(fout,"\n#\n_pdbx_validate_overall.program  %s\n", pdbx_validate_overall.program);
        fprintf(fout,"_pdbx_validate_overall.clashscore  %.2f\n", a1);
        fprintf(fout,"_pdbx_validate_overall.ramachandran_outlier_percent  %.2f\n", a2);
        fprintf(fout,"_pdbx_validate_overall.ramachandran_favored_percent  %.2f\n", a3);
    }
*/
    
//    write_computing(fout);
    if(index>0) write_index(fout);
    
    write_cell_symmetry(fout);
    write_exptl_crystal(fout);
    
    if(scl_s || ref ){
        write_reflns_shell(fout);
        write_reflns(fout);
    }
    if (ref){
        write_refine(fout);
        write_refine_ls_shell(fout);
    }
    if(refine_hist.d_res_high>0 && refine_hist.d_res_low>0){write_refine_hist(fout);}
    if(mr>0) write_mr(fout);
    if(dm>0) write_dm(fout);
    if(strstr_case(method, "MAD")) write_mad(fout);
    if(exptl_crystal_grow.pH>0 || exptl_crystal_grow.temp>0) {write_exptl_crystal_grow(fout);}
    write_diffrn_source(fout);
    write_diffrn_detector(fout);
    write_diffrn_radiation(fout);
    write_diffrn(fout);
    write_diffrn_radiation_wavelength(fout);
    write_refine_analyze(fout); 
    
}


void write_refine_analyze_run(FILE *fout, REFINE_ANALYZE x){
    fprintf(fout,"%s  ", DATA_BLOCK);
    (x.pdbx_refine_id)? fprintf(fout," '%s' ", x.pdbx_refine_id) : fprintf(fout," 1 ");
    (x.Luzzati_coordinate_error_obs>IN)? fprintf(fout," %6.3f ",x.Luzzati_coordinate_error_obs) : fprintf(fout," ? ");
    (x.Luzzati_sigma_a_obs>IN)? fprintf(fout," %6.3f ",x.Luzzati_sigma_a_obs) : fprintf(fout," ? ");
    (x.Luzzati_d_res_low_obs>IN)? fprintf(fout," %6.3f ",x.Luzzati_d_res_low_obs) : fprintf(fout," ? ");
    (x.Luzzati_coordinate_error_free>IN)? fprintf(fout," %6.3f ",x.Luzzati_coordinate_error_free) : fprintf(fout," ? ");
    (x.Luzzati_sigma_a_free>IN)? fprintf(fout," %6.3f ",x.Luzzati_sigma_a_free) : fprintf(fout," ? ");
    fprintf(fout, "\n");
}                                  
void write_refine_analyze(FILE *fout)
{

    if (refine_analyze.pdbx_refine_id[0]=='?' && !diffrn_neut.id) return;
    
    fprintf(fout,"loop_ \n \
_refine_analyze.entry_id\n \
_refine_analyze.pdbx_refine_id\n \
_refine_analyze.Luzzati_coordinate_error_obs\n \
_refine_analyze.Luzzati_sigma_a_obs\n \
_refine_analyze.Luzzati_d_res_low_obs\n \
_refine_analyze.Luzzati_coordinate_error_free \n \
_refine_analyze.Luzzati_sigma_a_free \n \
");
    if (refine_analyze.pdbx_refine_id) write_refine_analyze_run(fout, refine_analyze);
    if (refine_analyze_neut.pdbx_refine_id) write_refine_analyze_run(fout, refine_analyze_neut);
}


void write_diffrn_radiation_wavelength(FILE *fout)
//based on diffrn_source.pdbx_wavelength
{
    int ntok, n=0, i;
    char **token, tmp[80];
    
    if (strlen(diffrn_source.pdbx_wavelength)>2 || strlen(diffrn_source_neut.pdbx_wavelength)>2){
        fprintf(fout,"\nloop_\n");
        fprintf(fout,"_diffrn_radiation_wavelength.id \n");
        fprintf(fout,"_diffrn_radiation_wavelength.wavelength \n");
        fprintf(fout,"_diffrn_radiation_wavelength.wt \n");

        if (strlen(diffrn_source.pdbx_wavelength)>2){
            (strchr(diffrn_source.pdbx_wavelength, ','))? strcpy(tmp,","):strcpy(tmp,"-");
            token=string_token(diffrn_source.pdbx_wavelength, tmp, &ntok);
            for(i=0; i<ntok; i++){
                n=n+1;
                rid_of_front_end_space(token[i]);
                fprintf(fout,"%d '%s' 1 \n",n, token[i]);
            }
        }
        

        if (strlen(diffrn_source_neut.pdbx_wavelength)>2){
            (strchr(diffrn_source_neut.pdbx_wavelength, '-'))? strcpy(tmp,"-"):strcpy(tmp,",");
            token=string_token(diffrn_source_neut.pdbx_wavelength, tmp, &ntok);
            for(i=0; i<ntok; i++){
                n=n+1;
                rid_of_front_end_space(token[i]);
                fprintf(fout,"%d '%s' 1 \n",n, token[i]);
            }
        }
        
    }
    
}

void write_exptl_crystal_grow(FILE *fout)
{
    fprintf(fout,"\nloop_\n");
    fprintf(fout,"_exptl_crystal_grow.crystal_id \n");
    fprintf(fout,"_exptl_crystal_grow.method\n");
    fprintf(fout,"_exptl_crystal_grow.pH \n");
    fprintf(fout,"_exptl_crystal_grow.temp\n");
    fprintf(fout,"_exptl_crystal_grow.pdbx_details\n");
    
    (exptl_crystal_grow.crystal_id) ? fprintf(fout," %s ",exptl_crystal_grow.crystal_id) : fprintf(fout," 1 ");
    (exptl_crystal_grow.method) ? fprintf(fout," '%s' ", exptl_crystal_grow.method) : fprintf(fout," ? ");
    (exptl_crystal_grow.pH>0) ? fprintf(fout," %.2f ", exptl_crystal_grow.pH) : fprintf(fout," ? ");
    (exptl_crystal_grow.temp>0) ? fprintf(fout," %.2f ", exptl_crystal_grow.temp) : fprintf(fout," ? ");
    (strlen(exptl_crystal_grow.pdbx_details)>2) ? fprintf(fout," '%s' ", exptl_crystal_grow.pdbx_details) : fprintf(fout," ? ");
   
    fprintf(fout, "\n");
}

void write_diffrn(FILE *fout){
    if (diffrn.id[0]=='?' && !diffrn_neut.id) return;

    fprintf(fout,"loop_ \n \
_diffrn.id\n \
_diffrn.ambient_temp\n \
_diffrn.crystal_id\n \
");
    if (diffrn.id) write_diffrn_run(fout, diffrn);
    if (diffrn_neut.id) write_diffrn_run(fout, diffrn_neut);
}

void write_diffrn_run(FILE *fout, DIFFRN diffrn){
    (diffrn.id) ? fprintf(fout," %s ",diffrn.id) : fprintf(fout," ? ");
    (diffrn.ambient_temp>0) ? fprintf(fout," %.3f ",diffrn.ambient_temp) : fprintf(fout," ? ");
    (diffrn.crystal_id) ? fprintf(fout," %s ",diffrn.crystal_id) : fprintf(fout," 1 ");
    fprintf(fout, "\n");
}

void write_diffrn_source(FILE *fout){
    
    if (diffrn_source.diffrn_id[0]=='?' && !diffrn_source_neut.diffrn_id) return;
    
    fprintf(fout,"loop_ \n \
_diffrn_source.diffrn_id\n \
_diffrn_source.source\n \
_diffrn_source.type\n \
_diffrn_source.pdbx_synchrotron_site\n \
_diffrn_source.pdbx_synchrotron_beamline\n \
_diffrn_source.pdbx_wavelength\n \
_diffrn_source.pdbx_wavelength_list\n \
");
    if (diffrn_source.diffrn_id) write_diffrn_source_run(fout, diffrn_source);
    if (diffrn_source_neut.diffrn_id) write_diffrn_source_run(fout, diffrn_source_neut);
}

void write_diffrn_source_run(FILE *fout, DIFFRN_SOURCE diffrn_source){
    
    (diffrn_source.diffrn_id) ? fprintf(fout," %s ",diffrn_source.diffrn_id) : fprintf(fout," ? ");
    (diffrn_source.source) ? fprintf(fout," '%s' ",diffrn_source.source) : fprintf(fout," ? ");
    (diffrn_source.type) ? fprintf(fout," '%s' ",diffrn_source.type) : fprintf(fout," ? ");
    (diffrn_source.pdbx_synchrotron_site) ? fprintf(fout," '%s' ",diffrn_source.pdbx_synchrotron_site) : fprintf(fout," ? ");
    (diffrn_source.pdbx_synchrotron_beamline) ? fprintf(fout," '%s' ",diffrn_source.pdbx_synchrotron_beamline) : fprintf(fout," ? ");
    (diffrn_source.pdbx_wavelength) ? fprintf(fout," '%s' ",diffrn_source.pdbx_wavelength) : fprintf(fout," ? ");
    (diffrn_source.pdbx_wavelength_list) ? fprintf(fout," '%s' ",diffrn_source.pdbx_wavelength_list) : fprintf(fout," ? ");
    fprintf(fout, "\n");
}

void write_diffrn_detector(FILE *fout){

    if (diffrn_detector.diffrn_id[0]=='?' && !diffrn_detector_neut.diffrn_id) return;    

    fprintf(fout,"loop_ \n \
_diffrn_detector.diffrn_id \n \
_diffrn_detector.detector \n \
_diffrn_detector.type \n \
_diffrn_detector.pdbx_collection_date \n \
_diffrn_detector.details \n \
");
    if (diffrn_detector.diffrn_id) write_diffrn_detector_run(fout, diffrn_detector);
    if (diffrn_detector_neut.diffrn_id) write_diffrn_detector_run(fout, diffrn_detector_neut);
}

void write_diffrn_detector_run(FILE *fout, DIFFRN_DETECTOR diffrn_detector){
    
    (diffrn_detector.diffrn_id) ? fprintf(fout," '%s' ",diffrn_detector.diffrn_id) : fprintf(fout," ? ");
    (diffrn_detector.detector) ? fprintf(fout," '%s' ",diffrn_detector.detector) : fprintf(fout," ? ");
    (diffrn_detector.type) ? fprintf(fout," '%s' ",diffrn_detector.type) : fprintf(fout," ? ");
    (strlen(diffrn_detector.pdbx_collection_date)>2) ? fprintf(fout," '%s' ",diffrn_detector.pdbx_collection_date) : fprintf(fout," ? ");
    (diffrn_detector.details) ? fprintf(fout," '%s' ",diffrn_detector.details) : fprintf(fout," ? ");
    fprintf(fout, "\n");    

}

void write_diffrn_radiation(FILE *fout){
    if (diffrn_radiation.diffrn_id[0]=='?' && !diffrn_radiation_neut.diffrn_id) return;
    
    fprintf(fout,"loop_ \n \
_diffrn_radiation.diffrn_id \n \
_diffrn_radiation.wavelength_id \n \
_diffrn_radiation.pdbx_monochromatic_or_laue_m_l \n \
_diffrn_radiation.monochromator \n \
_diffrn_radiation.pdbx_diffrn_protocol \n \
_diffrn_radiation.pdbx_scattering_type \n \
");
    if (diffrn_radiation.diffrn_id) write_diffrn_radiation_run(fout, diffrn_radiation);
    if (diffrn_radiation_neut.diffrn_id) write_diffrn_radiation_run(fout, diffrn_radiation_neut);
}

void write_diffrn_radiation_run(FILE *fout, DIFFRN_RADIATION diffrn_radiation){
    (diffrn_radiation.diffrn_id) ? fprintf(fout," '%s' ",diffrn_radiation.diffrn_id) : fprintf(fout," ? ");
    (diffrn_radiation.wavelength_id) ? fprintf(fout," '%s' ",diffrn_radiation.wavelength_id) : fprintf(fout," ? ");
    (diffrn_radiation.pdbx_monochromatic_or_laue_m_l) ? fprintf(fout," '%s' ",diffrn_radiation.pdbx_monochromatic_or_laue_m_l) : fprintf(fout," ? ");
    (diffrn_radiation.monochromator) ? fprintf(fout," '%s' ",diffrn_radiation.monochromator) : fprintf(fout," ? ");
    (diffrn_radiation.pdbx_diffrn_protocol) ? fprintf(fout," '%s' ",diffrn_radiation.pdbx_diffrn_protocol) : fprintf(fout," ? ");
    (diffrn_radiation.pdbx_scattering_type) ? fprintf(fout," '%s' ",diffrn_radiation.pdbx_scattering_type) : fprintf(fout," ? ");
    fprintf(fout, "\n");    
}

void write_mr(FILE *fout)
{
    
    fprintf(fout,"\n## Category = pdbx_phasing_MR\n");
    fprintf(fout,"\nloop_\n");
    fprintf(fout, "_pdbx_phasing_MR.entry_id\n");
    fprintf(fout, "_pdbx_phasing_MR.method_rotation\n");
    fprintf(fout, "_pdbx_phasing_MR.method_translation\n");
    fprintf(fout, "_pdbx_phasing_MR.model_details\n");
    fprintf(fout, "_pdbx_phasing_MR.R_factor\n");
    fprintf(fout, "_pdbx_phasing_MR.R_rigid_body\n");
    fprintf(fout, "_pdbx_phasing_MR.correlation_coeff_Fo_to_Fc\n");
    fprintf(fout, "_pdbx_phasing_MR.correlation_coeff_Io_to_Ic\n");
    fprintf(fout, "_pdbx_phasing_MR.d_res_high_rotation\n");
    fprintf(fout, "_pdbx_phasing_MR.d_res_low_rotation\n");
    fprintf(fout, "_pdbx_phasing_MR.d_res_high_translation\n");
    fprintf(fout, "_pdbx_phasing_MR.d_res_low_translation\n");
    fprintf(fout, "_pdbx_phasing_MR.d_res_high_fit\n");
    fprintf(fout, "_pdbx_phasing_MR.d_res_low_fit\n");
    fprintf(fout, "_pdbx_phasing_MR.packing\n");
    fprintf(fout, "_pdbx_phasing_MR.reflns_percent_rotation\n");
    fprintf(fout, "_pdbx_phasing_MR.reflns_percent_translation\n");
    fprintf(fout, "_pdbx_phasing_MR.sigma_F_rotation\n");
    fprintf(fout, "_pdbx_phasing_MR.sigma_F_translation\n");
    fprintf(fout, "_pdbx_phasing_MR.sigma_I_rotation\n");
    fprintf(fout, "_pdbx_phasing_MR.sigma_I_translation\n");

    fprintf(fout, "_pdbx_phasing_MR.zscore_rotation\n");
    fprintf(fout, "_pdbx_phasing_MR.LL_gain_rotation\n");
    fprintf(fout, "_pdbx_phasing_MR.zscore_translation\n");
    fprintf(fout, "_pdbx_phasing_MR.LL_gain_translation\n");
    
/*        
    fprintf(fout, "_pdbx_phasing_MR.angle_alpha\n");
    fprintf(fout, "_pdbx_phasing_MR.angle_beta\n");
    fprintf(fout, "_pdbx_phasing_MR.angle_gamma\n");
    fprintf(fout, "_pdbx_phasing_MR.Cartn_x\n");
    fprintf(fout, "_pdbx_phasing_MR.Cartn_y\n");
    fprintf(fout, "_pdbx_phasing_MR.Cartn_z\n");
    fprintf(fout, "_pdbx_phasing_MR.fract_x\n");
    fprintf(fout, "_pdbx_phasing_MR.fract_y\n");
    fprintf(fout, "_pdbx_phasing_MR.fract_z\n");
*/
    fprintf(fout," \"%s\" ",DATA_BLOCK);
    (pdbx_phasing_MR.method_rotation[0]!='?') ? fprintf(fout," \"%s\" ",pdbx_phasing_MR.method_rotation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.method_translation[0]!='?') ? fprintf(fout," \"%s\" ",pdbx_phasing_MR.method_translation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.model_details[0]!='?') ? fprintf(fout," \"%s\" ",pdbx_phasing_MR.model_details) : fprintf(fout," ? ");
    (pdbx_phasing_MR.R_factor >INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.R_factor) : fprintf(fout," ? ");
    (pdbx_phasing_MR.R_rigid_body>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.R_rigid_body) : fprintf(fout," ? ");
    (pdbx_phasing_MR.correlation_coeff_Fo_to_Fc>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.correlation_coeff_Fo_to_Fc) : fprintf(fout," ? ");
    (pdbx_phasing_MR.correlation_coeff_Io_to_Ic>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.correlation_coeff_Io_to_Ic) : fprintf(fout," ? ");
    (pdbx_phasing_MR.d_res_high_rotation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.d_res_high_rotation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.d_res_low_rotation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.d_res_low_rotation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.d_res_high_translation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.d_res_high_translation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.d_res_low_translation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.d_res_low_translation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.d_res_high_fit>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.d_res_high_fit) : fprintf(fout," ? ");
    (pdbx_phasing_MR.d_res_low_fit>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.d_res_low_fit) : fprintf(fout," ? ");
    (pdbx_phasing_MR.packing>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.packing) : fprintf(fout," ? ");
    (pdbx_phasing_MR.reflns_percent_rotation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.reflns_percent_rotation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.reflns_percent_translation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.reflns_percent_translation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.sigma_F_rotation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.sigma_F_rotation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.sigma_F_translation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.sigma_F_translation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.sigma_I_rotation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.sigma_I_rotation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.sigma_I_translation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.sigma_I_translation) : fprintf(fout," ? ");

    (pdbx_phasing_MR.zscore_rotation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.zscore_rotation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.LL_gain_rotation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.LL_gain_rotation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.zscore_translation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.zscore_translation) : fprintf(fout," ? ");
    (pdbx_phasing_MR.LL_gain_translation>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.LL_gain_translation) : fprintf(fout," ? ");
    
/*    
    (pdbx_phasing_MR.angle_alpha>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.angle_alpha) : fprintf(fout," ? ");
    (pdbx_phasing_MR.angle_beta>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.angle_beta) : fprintf(fout," ? ");
    (pdbx_phasing_MR.angle_gamma>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.angle_gamma) : fprintf(fout," ? ");
    (pdbx_phasing_MR.Cartn_x>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.Cartn_x) : fprintf(fout," ? ");
    (pdbx_phasing_MR.Cartn_y>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.Cartn_y) : fprintf(fout," ? ");
    (pdbx_phasing_MR.Cartn_z>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.Cartn_z) : fprintf(fout," ? ");
    (pdbx_phasing_MR.fract_x>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.fract_x) : fprintf(fout," ? ");
    (pdbx_phasing_MR.fract_y>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.fract_y) : fprintf(fout," ? ");
    (pdbx_phasing_MR.fract_z>INI) ? fprintf(fout," %.3f ",pdbx_phasing_MR.fract_z) : fprintf(fout," ? ");
*/    
    fprintf(fout, "\n");
}

void write_dm(FILE *fout)
{
    int i;

    
    fprintf(fout,"_pdbx_phasing_dm.entry_id \"%s\"\n", DATA_BLOCK);
    
    if(pdbx_phasing_dm.mask_type[0] != '?')
        fprintf(fout,"_pdbx_phasing_dm.mask_type \"%s\"\n", pdbx_phasing_dm.mask_type);
    
    if(pdbx_phasing_dm.method[0] != '?')
        fprintf(fout,"_pdbx_phasing_dm.method \"%s\"\n", pdbx_phasing_dm.method);

    
    if(pdbx_phasing_dm.delta_phi_final>INI)
        fprintf(fout,"_pdbx_phasing_dm.delta_phi_final %.3f\n", pdbx_phasing_dm.delta_phi_final);
    
    if(pdbx_phasing_dm.delta_phi_initial>INI)
        fprintf(fout,"_pdbx_phasing_dm.delta_phi_initial %.3f\n", pdbx_phasing_dm.delta_phi_initial);
    
    if(pdbx_phasing_dm.fom_acentric>INI)
        fprintf(fout,"_pdbx_phasing_dm.fom_acentric %.3f\n", pdbx_phasing_dm.fom_acentric);
    
    if(pdbx_phasing_dm.fom_centric>INI)
        fprintf(fout,"_pdbx_phasing_dm.fom_centric %.3f\n", pdbx_phasing_dm.fom_centric);
    
    if(pdbx_phasing_dm.fom>INI)
        fprintf(fout,"_pdbx_phasing_dm.fom %.3f\n", pdbx_phasing_dm.fom);
    
    if(pdbx_phasing_dm.reflns_acentric>INI)
        fprintf(fout,"_pdbx_phasing_dm.reflns_acentric %d\n", pdbx_phasing_dm.reflns_acentric);
    
    if(pdbx_phasing_dm.reflns_centric>INI)
        fprintf(fout,"_pdbx_phasing_dm.reflns_centric %d\n", pdbx_phasing_dm.reflns_centric);
    
    if(pdbx_phasing_dm.reflns>INI)
        fprintf(fout,"_pdbx_phasing_dm.reflns %d\n", pdbx_phasing_dm.reflns);
/*    
    if(pdbx_phasing_dm.mask_radius>INI)
        fprintf(fout,"_pdbx_phasing_dm.mask_radius %.3f\n", pdbx_phasing_dm.mask_radius);
    if(pdbx_phasing_dm.d_res_high>INI)
        fprintf(fout,"_pdbx_phasing_dm.d_res_high %.3f\n", pdbx_phasing_dm.d_res_high);
    if(pdbx_phasing_dm.d_res_low>INI)
        fprintf(fout,"_pdbx_phasing_dm.d_res_low %.3f\n", pdbx_phasing_dm.d_res_low);
    if(pdbx_phasing_dm.protein_percent_sol>INI)
        fprintf(fout,"_pdbx_phasing_dm.protein_percent_sol %.3f\n", pdbx_phasing_dm.protein_percent_sol);
    
    if(pdbx_phasing_dm.protein_min_density>INI)
        fprintf(fout,"_pdbx_phasing_dm.protein_min_density %.3f\n", pdbx_phasing_dm.protein_min_density);
    if(pdbx_phasing_dm.protein_max_density>INI)
        fprintf(fout,"_pdbx_phasing_dm.protein_max_density %.3f\n", pdbx_phasing_dm.protein_max_density);
    
    if(pdbx_phasing_dm.protein_mean_density>INI)
        fprintf(fout,"_pdbx_phasing_dm.protein_mean_density %.3f\n", pdbx_phasing_dm.protein_mean_density);
    if(pdbx_phasing_dm.protein_mean_density_esd>INI)
        fprintf(fout,"_pdbx_phasing_dm.protein_mean_density_esd %.3f\n", pdbx_phasing_dm.protein_mean_density_esd);
    
    if(pdbx_phasing_dm.solvent_percent_sol>INI)
        fprintf(fout,"_pdbx_phasing_dm.solvent_percent_sol %.3f\n", pdbx_phasing_dm.solvent_percent_sol);
    if(pdbx_phasing_dm.solvent_min_density>INI)
        fprintf(fout,"_pdbx_phasing_dm.solvent_min_density %.3f\n", pdbx_phasing_dm.solvent_min_density);
    
    if(pdbx_phasing_dm.solvent_max_density>INI)
        fprintf(fout,"_pdbx_phasing_dm.solvent_max_density %.3f\n", pdbx_phasing_dm.solvent_max_density);
    if(pdbx_phasing_dm.solvent_mean_density>INI)
        fprintf(fout,"_pdbx_phasing_dm.solvent_mean_density %.3f\n", pdbx_phasing_dm.solvent_mean_density);
    
    if(pdbx_phasing_dm.solvent_mean_density_esd>INI)
        fprintf(fout,"_pdbx_phasing_dm.solvent_mean_density_esd %.3f\n", pdbx_phasing_dm.solvent_mean_density_esd);

  
    if(pdbx_phasing_dm.prior_map_CC_acentric>INI)
        fprintf(fout,"_pdbx_phasing_dm.prior_map_CC_acentric %.3f\n", pdbx_phasing_dm.prior_map_CC_acentric);

    if(pdbx_phasing_dm.prior_map_CC_centric>INI)
        fprintf(fout,"_pdbx_phasing_dm.prior_map_CC_centric %.3f\n", pdbx_phasing_dm.prior_map_CC_centric);

    if(pdbx_phasing_dm.prior_map_CC>INI)
        fprintf(fout,"_pdbx_phasing_dm.prior_map_CC %.3f\n", pdbx_phasing_dm.prior_map_CC);
*/
    
    if(pdbx_phasing_dm_shell.number_bin>=1){
        fprintf(fout,"\n\n##### Density modification #####\n");
        fprintf(fout,"loop_\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.d_res_high\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.d_res_low\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.delta_phi_final\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.delta_phi_initial\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.fom_acentric\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.fom_centric\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.fom\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.reflns_acentric\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.reflns_centric\n");
        fprintf(fout,"_pdbx_phasing_dm_shell.reflns\n");
        
//        fprintf(fout,"_pdbx_phasing_dm_shell.prior_map_CC_acentric\n");
//        fprintf(fout,"_pdbx_phasing_dm_shell.prior_map_CC_centric\n");
//        fprintf(fout,"_pdbx_phasing_dm_shell.prior_map_CC\n");
        for(i=0; i<pdbx_phasing_dm_shell.number_bin; i++){
            (pdbx_phasing_dm_shell.d_res_high[i]>0)?
                fprintf(fout," %.3f ", pdbx_phasing_dm_shell.d_res_high[i]) : fprintf(fout," ?\n");
         
            (pdbx_phasing_dm_shell.d_res_low[i]>0)?
                fprintf(fout," %.3f ", pdbx_phasing_dm_shell.d_res_low[i]) : fprintf(fout," ? ");
         
            (pdbx_phasing_dm_shell.delta_phi_final[i]>0)?
                fprintf(fout," %.3f ", pdbx_phasing_dm_shell.delta_phi_final[i]) : fprintf(fout," ? ");
         
            (pdbx_phasing_dm_shell.delta_phi_initial[i]>0)?
                fprintf(fout," %.3f ", pdbx_phasing_dm_shell.delta_phi_initial[i]) : fprintf(fout," ? ");
         
            (pdbx_phasing_dm_shell.fom_acentric[i]>0)?
                fprintf(fout," %.3f ", pdbx_phasing_dm_shell.fom_acentric[i]) : fprintf(fout," ? ");
         
            (pdbx_phasing_dm_shell.fom_centric[i]>0)?
                fprintf(fout," %.3f ", pdbx_phasing_dm_shell.fom_centric[i]) : fprintf(fout," ? ");
         
            (pdbx_phasing_dm_shell.fom[i]>0)?
                fprintf(fout," %.3f ", pdbx_phasing_dm_shell.fom[i]) : fprintf(fout," ? ");
         
            (pdbx_phasing_dm_shell.reflns_acentric[i]>0)?
                fprintf(fout," %d ", pdbx_phasing_dm_shell.reflns_acentric[i]) : fprintf(fout," ? ");

            (pdbx_phasing_dm_shell.reflns_centric[i]>0)?
                fprintf(fout," %d ", pdbx_phasing_dm_shell.reflns_centric[i]) : fprintf(fout," ? ");
         
            (pdbx_phasing_dm_shell.reflns[i]>0)?
                fprintf(fout," %d ", pdbx_phasing_dm_shell.reflns[i]) : fprintf(fout," ? ");
/*
            
            (pdbx_phasing_dm_shell.prior_map_CC_acentric[i]>0)?
                fprintf(fout," %.3f ", pdbx_phasing_dm_shell.prior_map_CC_acentric[i]) : fprintf(fout," ? ");
            
            (pdbx_phasing_dm_shell.prior_map_CC_centric[i]>0)?
                fprintf(fout," %.3f ", pdbx_phasing_dm_shell.prior_map_CC_centric[i]) : fprintf(fout," ? ");
            
            (pdbx_phasing_dm_shell.prior_map_CC[i]>0)?
                fprintf(fout," %.3f ", pdbx_phasing_dm_shell.prior_map_CC[i]) : fprintf(fout," ? ");
*/            
            fprintf(fout,"\n");
            
        }
    }
    

}
void write_mad(FILE *fout)
{
 //_phasing_mad
    if(phasing_mad.pdbx_d_res_high && phasing_mad.pdbx_d_res_low){
        fprintf(fout, "_phasing_MAD.entry_id  '%s'\n",DATA_BLOCK);
        fprintf(fout, "_phasing_mad.pdbx_d_res_high  '%.2f'\n", phasing_mad.pdbx_d_res_high);
    
        fprintf(fout, "_phasing_mad.pdbx_d_res_low  '%.2f'\n", phasing_mad.pdbx_d_res_low);
        
    }
    
}


void write_cell_symmetry(FILE *fout)
{
    char sg[20];
    
 //cell
    if(cell.length_a>0) {
        fprintf(fout,"#\n");
    
        fprintf(fout,"_cell.entry_id \"%s\"\n", DATA_BLOCK);
        fprintf(fout,"_cell.length_a ");
        (cell.length_a>0) ? fprintf(fout," %8.3f\n", cell.length_a) : fprintf(fout,"?\n");
    
        fprintf(fout,"_cell.length_b ");
        (cell.length_b>0) ? fprintf(fout," %8.3f\n", cell.length_b) : fprintf(fout,"?\n");

        fprintf(fout,"_cell.length_c ");
        (cell.length_c>0) ? fprintf(fout," %8.3f\n", cell.length_c) : fprintf(fout,"?\n");

        fprintf(fout,"_cell.angle_alpha  ");
        (cell.angle_alpha>0) ? fprintf(fout," %8.3f\n", cell.angle_alpha ) : fprintf(fout,"?\n");

        fprintf(fout,"_cell.angle_beta  ");
        (cell.angle_beta>0) ? fprintf(fout," %8.3f\n", cell.angle_beta ) : fprintf(fout,"?\n");

        fprintf(fout,"_cell.angle_gamma   ");
        (cell.angle_gamma >0) ? fprintf(fout," %8.3f\n", cell.angle_gamma  ) : fprintf(fout,"?\n");

        if(cell.length_a_esd>=0) fprintf(fout,"_cell.length_a_esd %.3f\n ", cell.length_a_esd);
        if(cell.length_b_esd>=0) fprintf(fout,"_cell.length_b_esd %.3f\n ", cell.length_b_esd);
        if(cell.length_c_esd>=0) fprintf(fout,"_cell.length_c_esd %.3f\n ", cell.length_c_esd);
        if(cell.angle_alpha_esd>=0) fprintf(fout,"_cell.angle_alpha_esd %.3f\n ", cell.angle_alpha_esd);
        if(cell.angle_beta_esd>=0) fprintf(fout,"_cell.angle_beta_esd %.3f\n ", cell.angle_beta_esd);
        if(cell.angle_gamma_esd>=0) fprintf(fout,"_cell.angle_gamma_esd %.3f\n ", cell.angle_gamma_esd);
    }

    
// symmetry    
    if(symmetry.Int_Tables_number>0 || strlen(symmetry.space_group_name_H_M)>1){
        
        fprintf(fout,"#\n");
        
        fprintf(fout,"_symmetry.entry_id %s\n", DATA_BLOCK);
        if (symmetry.Int_Tables_number>0) 
            fprintf(fout,"_symmetry.Int_Tables_number  %d\n", symmetry.Int_Tables_number);
        space_group_convertor(symmetry.space_group_name_H_M, sg);
        
        fprintf(fout,"_symmetry.space_group_name_H-M  '%s' \n", sg);
    }
    
    
}



void write_refine_hist(FILE *fout)
{

    if  (refine_hist.number_atoms_total<0) return;
    
    fprintf(fout,"\n#\n_refine_hist.cycle_id    final \n");
    fprintf(fout,"_refine_hist.pdbx_refine_id      '%s'\n", exptl.method);
    fprintf(fout,"_refine_hist.d_res_high  %.2f\n", refine_hist.d_res_high);
    fprintf(fout,"_refine_hist.d_res_low   %.2f\n", refine_hist.d_res_low);
    
    if (refine_hist.pdbx_number_atoms_ligand>=0){
        fprintf(fout,"_refine_hist.pdbx_number_atoms_ligand  %d\n", refine_hist.pdbx_number_atoms_ligand);
    }
    
    if (refine_hist.number_atoms_solvent>=0) fprintf(fout,"_refine_hist.number_atoms_solvent  %d\n", refine_hist.number_atoms_solvent);
    if (refine_hist.number_atoms_total>=0) fprintf(fout,"_refine_hist.number_atoms_total   %d\n", refine_hist.number_atoms_total);
    if (refine_hist.number_residue_total>=0) fprintf(fout,"_refine_hist.pdbx_number_residues_total   %d\n", refine_hist.number_residue_total);
    if (refine_hist.pdbx_B_iso_mean_ligand>0) fprintf(fout,"_refine_hist.pdbx_B_iso_mean_ligand   %.2f\n", refine_hist.pdbx_B_iso_mean_ligand);
    if (refine_hist.pdbx_B_iso_mean_solvent>0) fprintf(fout,"_refine_hist.pdbx_B_iso_mean_solvent  %.2f\n", refine_hist.pdbx_B_iso_mean_solvent);
}



void write_computing(FILE *fout)
//.data_collection changed to pdbx_data_reduction_ds
//.data_collection changed to pdbx_data_reduction_ii  
{
    
    fprintf(fout,"_computing.entry_id  \"%s\" \n", DATA_BLOCK);
    fprintf(fout,"_computing.structure_refinement  \"%s\" \n", computing.structure_refinement);
    fprintf(fout,"_computing.structure_solution  \"%s\" \n", computing.structure_solution);
//    fprintf(fout,"_computing.pdbx_density_modification  \"%s\" \n", computing.pdbx_density_modification);
    fprintf(fout,"_computing.pdbx_data_reduction_ds \"%s\" \n", computing.data_reduction);
    fprintf(fout,"_computing.pdbx_data_reduction_ii  \"%s\" \n", computing.data_collection);
    fprintf(fout,"_computing.cell_refinement  \"%s\" \n", computing.cell_refinement);
}


void write_index(FILE *fout)
{
    const char *items[22] =
        {
            "crystal_id",
            "oscillation_range",
            "oscillation_start",
            "oscillation_end",
            "xbeam",
            "xbeam_esd",
            "ybeam",
            "ybeam_esd",
            "crysx_spindle",
            "crysx_spindle_esd",
            "crysy_vertical",
            "crysy_vertical_esd",
            "crysz_beam",
            "crysz_beam_esd",
            "crystal_to_detector_distance",
            "crystal_to_detector_distance_esd",
            "crossfire_y",
            "crossfire_y_esd",
            "crossfire_x",
            "crossfire_x_esd",
            "crossfire_xy",
            "crossfire_xy_esd"
        };
    print_mmcif_head(fout,"_pdbx_crystal_alignment", items, 22);
    (pdbx_crystal_alignment.crystal_id>IN) ?fprintf(fout," %d ",pdbx_crystal_alignment.crystal_id): fprintf(fout," 1 ");
    (pdbx_crystal_alignment.oscillation_range>IN) ? fprintf(fout," %.3f ",pdbx_crystal_alignment.oscillation_range): fprintf(fout," ?");
    (pdbx_crystal_alignment.oscillation_start>IN) ? fprintf(fout," %.3f ",pdbx_crystal_alignment.oscillation_start): fprintf(fout," ?");
    (pdbx_crystal_alignment.oscillation_end>IN) ? fprintf(fout," %.3f ",pdbx_crystal_alignment.oscillation_end): fprintf(fout," ?");
    
    (pdbx_crystal_alignment.xbeam>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.xbeam): fprintf(fout," ? ");
    (pdbx_crystal_alignment.xbeam_esd>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.xbeam_esd): fprintf(fout," ? ");
    (pdbx_crystal_alignment.ybeam>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.ybeam): fprintf(fout," ? ");
    (pdbx_crystal_alignment.ybeam_esd>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.ybeam_esd): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crysx_spindle>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.crysx_spindle): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crysx_spindle_esd>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.crysx_spindle_esd): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crysy_vertical>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.crysy_vertical): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crysy_vertical_esd>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.crysy_vertical_esd): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crysz_beam>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.crysz_beam): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crysz_beam_esd>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.crysz_beam_esd): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crystal_to_detector_distance>IN) ?
        fprintf(fout," %.3f ",pdbx_crystal_alignment.crystal_to_detector_distance): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crystal_to_detector_distance_esd>IN) ?
        fprintf(fout," %.3f ",pdbx_crystal_alignment.crystal_to_detector_distance_esd): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crossfire_y>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.crossfire_y): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crossfire_y_esd>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.crossfire_y_esd): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crossfire_x>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.crossfire_x): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crossfire_x_esd>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.crossfire_x_esd): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crossfire_xy>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.crossfire_xy): fprintf(fout," ? ");
    (pdbx_crystal_alignment.crossfire_xy_esd>IN) ?fprintf(fout," %.3f ",pdbx_crystal_alignment.crossfire_xy_esd): fprintf(fout," ? ");

    fprintf(fout,"\n");

    if(axis.key>0){
        const char *item[6] =
            {
                "id",
                "type",
                "equipment",
                "vector[1]",
                "vector[2]",
                "vector[3]",
            };
        print_mmcif_head(fout,"_axis", item, 6);
        fprintf(fout,"omega rotation goniometer %.5f %.5f %.5f \n", axis.omega[0], axis.omega[1], axis.omega[2]);
        fprintf(fout,"kappa rotation goniometer %.5f %.5f %.5f \n", axis.kappa[0], axis.kappa[1], axis.kappa[2]);
        fprintf(fout,"phi   rotation goniometer %.5f %.5f %.5f \n", axis.phi[0], axis.phi[1], axis.phi[2]);
    }
        
}

    
void write_exptl_crystal(FILE *fout)
{
    if (!(exptl_crystal.density_Matthews>INI || exptl_crystal.pdbx_mosaicity>INI || exptl_crystal.density_percent_sol>INI)) return;
    const char *items[] =
        {
            "id",
            "pdbx_mosaicity",
            "pdbx_mosaicity_esd",
            "density_Matthews",
            "density_diffrn",
            "density_meas",
            "density_meas_temp",
            "density_percent_sol",
            "size_max",
            "size_mid",
            "size_min",
            "size_rad"
        };
    
    print_mmcif_head(fout,"_exptl_crystal", items, 12);
    
    (exptl_crystal.id>INI)? fprintf(fout," %d ",exptl_crystal.id):fprintf(fout," 1 ");
    (exptl_crystal.pdbx_mosaicity>INI)? fprintf(fout," %.3f  ",exptl_crystal.pdbx_mosaicity):fprintf(fout," ? ");
    (exptl_crystal.pdbx_mosaicity_esd>INI)? fprintf(fout," %.3f ",exptl_crystal.pdbx_mosaicity_esd):fprintf(fout," ? ");
    (exptl_crystal.density_Matthews>INI)? fprintf(fout," %.3f ",exptl_crystal.density_Matthews):fprintf(fout," ? ");
    (exptl_crystal.density_diffrn>INI)? fprintf(fout," %.3f ",exptl_crystal.density_diffrn):fprintf(fout," ? ");
    (exptl_crystal.density_meas>INI)? fprintf(fout," %.3f ",exptl_crystal.density_meas):fprintf(fout," ? ");
    (exptl_crystal.density_meas_temp>INI)? fprintf(fout," %.3f ",exptl_crystal.density_meas_temp):fprintf(fout," ? ");
    (exptl_crystal.density_percent_sol>INI)? fprintf(fout," %.3f ",exptl_crystal.density_percent_sol):fprintf(fout," ? ");
    (exptl_crystal.size_max>INI)? fprintf(fout," %.3f ",exptl_crystal.size_max):fprintf(fout," ? ");
    (exptl_crystal.size_mid>INI)? fprintf(fout," %.3f ",exptl_crystal.size_mid):fprintf(fout," ? ");
    (exptl_crystal.size_min>INI)? fprintf(fout," %.3f ",exptl_crystal.size_min):fprintf(fout," ? ");
    (exptl_crystal.size_rad>INI)? fprintf(fout," %.3f ",exptl_crystal.size_rad):fprintf(fout," ? ");
    
    fprintf(fout,"\n");
    
}
    
void write_refine(FILE *fout)
{
    
    fprintf(fout,"#\n");
    fprintf(fout,"loop_ \n \
_refine.entry_id \n \
_refine.pdbx_refine_id \n \
_refine.ls_d_res_high \n \
_refine.ls_d_res_low \n \
_refine.pdbx_ls_sigma_F \n \
_refine.pdbx_data_cutoff_high_absF \n \
_refine.pdbx_data_cutoff_low_absF \n \
_refine.ls_percent_reflns_obs \n \
_refine.ls_number_reflns_obs \n \
_refine.ls_number_reflns_all \n \
_refine.pdbx_ls_cross_valid_method \n \
_refine.ls_matrix_type \n \
_refine.pdbx_R_Free_selection_details \n \
_refine.details \n \
_refine.ls_R_factor_all \n \
_refine.ls_R_factor_obs \n \
_refine.ls_R_factor_R_work \n \
_refine.ls_wR_factor_R_work \n \
_refine.ls_R_factor_R_free \n \
_refine.ls_wR_factor_R_free \n \
_refine.ls_percent_reflns_R_free \n \
_refine.ls_number_reflns_R_free \n \
_refine.ls_number_reflns_R_work \n \
_refine.ls_R_factor_R_free_error \n \
_refine.B_iso_mean \n \
_refine.solvent_model_param_bsol \n \
_refine.solvent_model_param_ksol \n \
_refine.pdbx_isotropic_thermal_model  \n \
_refine.aniso_B[1][1] \n \
_refine.aniso_B[2][2] \n \
_refine.aniso_B[3][3] \n \
_refine.aniso_B[1][2] \n \
_refine.aniso_B[1][3]  \n \
_refine.aniso_B[2][3] \n \
_refine.correlation_coeff_Fo_to_Fc \n \
_refine.correlation_coeff_Fo_to_Fc_free \n \
_refine.overall_SU_R_Cruickshank_DPI \n \
_refine.pdbx_overall_SU_R_free_Cruickshank_DPI  \n \
_refine.pdbx_overall_SU_R_Blow_DPI  \n \
_refine.pdbx_overall_SU_R_free_Blow_DPI  \n \
_refine.overall_SU_R_free \n \
_refine.pdbx_overall_ESU_R  \n \
_refine.pdbx_overall_ESU_R_Free \n \
_refine.overall_SU_ML \n \
_refine.overall_SU_B \n \
_refine.solvent_model_details  \n \
_refine.pdbx_solvent_vdw_probe_radii  \n \
_refine.pdbx_solvent_ion_probe_radii \n \
_refine.pdbx_solvent_shrinkage_radii  \n \
_refine.ls_number_parameters  \n \
_refine.ls_number_restraints \n \
_refine.pdbx_starting_model \n \
_refine.pdbx_method_to_determine_struct \n \
_refine.pdbx_stereochemistry_target_values \n \
_refine.pdbx_stereochem_target_val_spec_case \n \
_refine.overall_FOM_work_R_set \n \
_refine.B_iso_max \n \
_refine.B_iso_min \n \
_refine.pdbx_overall_phase_error \n \
_refine.occupancy_max  \n \
_refine.occupancy_min  \n\n ");

        
    if (strstr(refine.pdbx_refine_id , "X-RAY")) {write_refine_run(fout, refine); }
    if (strstr(refine_neutron.pdbx_refine_id , "NEUTRON")) {write_refine_run(fout, refine_neutron);}
    
}

void write_refine_run(FILE *fout, REFINE refine)
{
    int ini=-9998;
    
        
        fprintf(fout,"%s  ",  DATA_BLOCK);
    (refine.pdbx_refine_id)? fprintf(fout," '%s' ", refine.pdbx_refine_id):fprintf(fout," ? ");

    (refine.ls_d_res_high >ini)? fprintf(fout,"  %.4f ", refine.ls_d_res_high):fprintf(fout," ? ");

    (refine.ls_d_res_low >ini)? fprintf(fout,"  %.4f ", refine.ls_d_res_low):fprintf(fout," ? ");
   
    (refine.pdbx_ls_sigma_F  >ini)? fprintf(fout,"   %.3f ", refine.pdbx_ls_sigma_F):fprintf(fout," ? ");
   
    (refine.pdbx_data_cutoff_high_absF >ini)? fprintf(fout,"  %.4f ", refine.pdbx_data_cutoff_high_absF):fprintf(fout," ? ");
   
    (refine.pdbx_data_cutoff_low_absF >ini)? fprintf(fout,"  %.4f ", refine.pdbx_data_cutoff_low_absF):fprintf(fout," ? ");
   
   (refine.ls_percent_reflns_obs >ini)? fprintf(fout,"  %.4f ", refine.ls_percent_reflns_obs):fprintf(fout," ? ");
   
   (refine.ls_number_reflns_obs >ini)? fprintf(fout,"  %d ", refine.ls_number_reflns_obs):fprintf(fout," ? ");

   (refine.ls_number_reflns_all >ini)? fprintf(fout,"  %d ", refine.ls_number_reflns_all):fprintf(fout," ? ");
   
   (refine.pdbx_ls_cross_valid_method[0] != '?')? fprintf(fout," \"%s\"  ", refine.pdbx_ls_cross_valid_method):fprintf(fout," THROUGHOUT ");   

   (refine.ls_matrix_type[0] != '?') ?fprintf(fout," \"%s\"   ", refine.ls_matrix_type):fprintf(fout," ? ");
   
   (refine.pdbx_R_Free_selection_details[0] !='?') ?fprintf(fout," \"%s\"   ", refine.pdbx_R_Free_selection_details):fprintf(fout," ? ");

   if (strlen(REF_DETAIL)>5){
       fprintf(fout,"\n;%s\n;\n  ", REF_DETAIL);
   }else{
       (refine.details[0] !='?' && strlen(refine.details) >2)? fprintf(fout," \"%s\"  ", refine.details):fprintf(fout," ? ");
   }
   
   (refine.ls_R_factor_all >ini)?  fprintf(fout,"  %.4f ", refine.ls_R_factor_all):fprintf(fout," ? ");
   
   (refine.ls_R_factor_obs >ini)? fprintf(fout,"  %.4f ", refine.ls_R_factor_obs):fprintf(fout," ? ");
   
   (refine.ls_R_factor_R_work >ini)? fprintf(fout,"  %.4f ", refine.ls_R_factor_R_work):fprintf(fout," ? ");
   
   (refine.ls_wR_factor_R_work >ini)? fprintf(fout,"  %.4f ", refine.ls_wR_factor_R_work):fprintf(fout," ? ");
   
   (refine.ls_R_factor_R_free >ini)? fprintf(fout,"  %.4f ", refine.ls_R_factor_R_free):fprintf(fout," ? ");
   
   (refine.ls_wR_factor_R_free >ini)? fprintf(fout,"  %.4f ", refine.ls_wR_factor_R_free):fprintf(fout," ? ");
   
   (refine.ls_percent_reflns_R_free >ini)? fprintf(fout,"  %.4f ", refine.ls_percent_reflns_R_free):fprintf(fout," ? ");
   
   (refine.ls_number_reflns_R_free >ini)? fprintf(fout,"  %d ", refine.ls_number_reflns_R_free):fprintf(fout," ? ");

   (refine.ls_number_reflns_R_work >0)? fprintf(fout,"  %d ", refine.ls_number_reflns_R_work):fprintf(fout," ? ");
   
   (refine.ls_R_factor_R_free_error >ini)? fprintf(fout,"  %.4f ", refine.ls_R_factor_R_free_error):fprintf(fout," ? ");

   (refine.B_iso_mean >ini)?  fprintf(fout,"  %.4f ", refine.B_iso_mean):fprintf(fout," ? ");

   (refine.solvent_model_param_bsol >ini)? fprintf(fout,"  %.4f ", refine.solvent_model_param_bsol):fprintf(fout," ? ");

   (refine.solvent_model_param_ksol >ini)? fprintf(fout," %.4f ", refine.solvent_model_param_ksol):fprintf(fout," ? ");
   
   (refine.pdbx_isotropic_thermal_model[0] != '?' )? fprintf(fout," \"%s\"  ", refine.pdbx_isotropic_thermal_model):fprintf(fout," ? ");

   (refine.aniso_B11 >ini)? fprintf(fout,"  %.4f ", refine.aniso_B11):fprintf(fout," ? ");

   (refine.aniso_B22 >ini)? fprintf(fout,"  %.4f ", refine.aniso_B22):fprintf(fout," ? ");

   (refine.aniso_B33 >ini)?  fprintf(fout,"  %.4f ", refine.aniso_B33):fprintf(fout," ? ");

   (refine.aniso_B12 >ini)? fprintf(fout,"  %.4f ", refine.aniso_B12):fprintf(fout," ? ");

   (refine.aniso_B13 >ini)? fprintf(fout," %.4f ", refine.aniso_B13):fprintf(fout," ? ");

   (refine.aniso_B23 >ini)? fprintf(fout,"  %.4f ", refine.aniso_B23):fprintf(fout," ? ");

   (refine.correlation_coeff_Fo_to_Fc >ini)? fprintf(fout,"  %.4f ", refine.correlation_coeff_Fo_to_Fc):fprintf(fout," ? ");

   (refine.correlation_coeff_Fo_to_Fc_free >ini)?fprintf(fout,"  %.4f ", refine.correlation_coeff_Fo_to_Fc_free):fprintf(fout," ? ");

   (refine.overall_SU_R_Cruickshank_DPI >ini)? fprintf(fout,"  %.4f ", refine.overall_SU_R_Cruickshank_DPI):fprintf(fout," ? ");

   (refine.pdbx_overall_SU_R_free_Cruickshank_DPI >ini)? fprintf(fout,"  %.4f ", refine.pdbx_overall_SU_R_free_Cruickshank_DPI):fprintf(fout," ? ");

   (refine.pdbx_overall_SU_R_Blow_DPI >ini)? fprintf(fout,"  %.4f ", refine.pdbx_overall_SU_R_Blow_DPI):fprintf(fout," ? ");

   (refine.pdbx_overall_SU_R_free_Blow_DPI >ini)? fprintf(fout,"  %.4f ", refine.pdbx_overall_SU_R_free_Blow_DPI):fprintf(fout," ? ");

   (refine.overall_SU_R_free >ini)? fprintf(fout,"  %.4f ", refine.overall_SU_R_free):fprintf(fout," ? ");

   (refine.pdbx_overall_ESU_R >ini)? fprintf(fout," %.4f ", refine.pdbx_overall_ESU_R):fprintf(fout," ? ");

   (refine.pdbx_overall_ESU_R_Free>ini)? fprintf(fout,"  %.4f ", refine.pdbx_overall_ESU_R_Free):fprintf(fout," ? ");

   (refine.overall_SU_ML >ini)? fprintf(fout,"  %.4f ", refine.overall_SU_ML):fprintf(fout," ? ");

   (refine.overall_SU_B >ini)? fprintf(fout,"  %.4f ", refine.overall_SU_B):fprintf(fout," ? ");

   (refine.solvent_model_details[0] !='?')? fprintf(fout," \"%s\" ", refine.solvent_model_details):fprintf(fout," ? ");

   (refine.pdbx_solvent_vdw_probe_radii >ini)?fprintf(fout," %.4f ", refine.pdbx_solvent_vdw_probe_radii):fprintf(fout," ? ");

   (refine.pdbx_solvent_ion_probe_radii >ini)? fprintf(fout,"  %.4f ", refine.pdbx_solvent_ion_probe_radii):fprintf(fout," ? ");

   (refine.pdbx_solvent_shrinkage_radii >ini)? fprintf(fout," %.4f ", refine.pdbx_solvent_shrinkage_radii):fprintf(fout," ? ");

   (refine.ls_number_parameters >ini)?  fprintf(fout," %d ", refine.ls_number_parameters):fprintf(fout," ? ");
   
   (refine.ls_number_restraints >ini)? fprintf(fout,"  %d ", refine.ls_number_restraints):fprintf(fout," ? ");

   if (strlen(REF_MODEL)>0){
       fprintf(fout," \"%s\" ",REF_MODEL);
   }else{
       (refine.pdbx_starting_model[0] !='?') ?fprintf(fout," \"%s\" ", refine.pdbx_starting_model):fprintf(fout," ? ");
   }
   
   if(strstr_case(refine.pdbx_method_to_determine_struct, "mr")) strcpy(refine.pdbx_method_to_determine_struct, "MOLECULAR REPLACEMENT");
   
   (refine.pdbx_method_to_determine_struct[0] !='?' && strlen(refine.pdbx_method_to_determine_struct)>0)?
       fprintf(fout," \"%s\" ",refine.pdbx_method_to_determine_struct ):fprintf(fout," ? ");      
   
   (refine.pdbx_stereochemistry_target_values [0] !='?')? fprintf(fout,"  \"%s\"  ", refine.pdbx_stereochemistry_target_values ):fprintf(fout," ? ");

   (refine.pdbx_stereochem_target_val_spec_case[0] !='?')? fprintf(fout,"  \"%s\"  ", refine.pdbx_stereochem_target_val_spec_case):fprintf(fout," ? ");

   (refine.overall_FOM_work_R_set >ini)? fprintf(fout," %.4f ", refine.overall_FOM_work_R_set):fprintf(fout," ? ");

   (refine.B_iso_max >ini)?  fprintf(fout," %.3f ", refine.B_iso_max):fprintf(fout," ? ");

   (refine.B_iso_min >ini)?  fprintf(fout," %.3f ", refine.B_iso_min):fprintf(fout," ? ");

   (refine.pdbx_overall_phase_error >ini)? fprintf(fout," %.4f ", refine.pdbx_overall_phase_error):fprintf(fout," ? ");

   (refine.occupancy_max >ini)? fprintf(fout," %.3f ", refine.occupancy_max):fprintf(fout," ? ");

   (refine.occupancy_min >ini)?  fprintf(fout," %.3f ", refine.occupancy_min):fprintf(fout," ? ");

   fprintf(fout,"\n"); 

}

void write_pdbx_refine(FILE *fout)
{
    
   fprintf(fout,"#\n");  //for pdbx_refine
   if(pdbx_refine.R_factor_all_4sig_cutoff >INI){
       fprintf(fout,"_pdbx_refine.pdbx_refine_id  '%s' \n", REFINE_ID[0]);
       fprintf(fout,"_pdbx_refine.R_factor_all_4sig_cutoff %.4f\n", pdbx_refine.R_factor_all_4sig_cutoff); 
   }
   
   if(pdbx_refine.R_factor_all_no_cutoff >INI)
       fprintf(fout,"_pdbx_refine.R_factor_all_no_cutoff %.4f\n", pdbx_refine.R_factor_all_no_cutoff); 
   if(pdbx_refine.R_factor_obs_4sig_cutoff >INI)
       fprintf(fout,"_pdbx_refine.R_factor_obs_4sig_cutoff %.4f\n", pdbx_refine.R_factor_obs_4sig_cutoff); 
   if(pdbx_refine.R_factor_obs_no_cutoff >INI)
       fprintf(fout,"_pdbx_refine.R_factor_obs_no_cutoff %.4f\n", pdbx_refine.R_factor_obs_no_cutoff); 
   if(pdbx_refine.free_R_factor_4sig_cutoff >INI)
       fprintf(fout,"_pdbx_refine.free_R_factor_4sig_cutoff %.4f\n", pdbx_refine.free_R_factor_4sig_cutoff); 
   if(pdbx_refine.free_R_factor_no_cutoff >INI)
       fprintf(fout,"_pdbx_refine.free_R_factor_no_cutoff %.4f\n", pdbx_refine.free_R_factor_no_cutoff); 
   if(pdbx_refine.free_R_val_4sig_cutoff >INI)
       fprintf(fout,"_pdbx_refine.free_R_val_4sig_cutoff %.4f\n", pdbx_refine.free_R_val_4sig_cutoff); 
   if(pdbx_refine.free_R_val_test_set_ct_4sig_cutoff >INI)
       fprintf(fout,"_pdbx_refine.free_R_val_test_set_ct_4sig_cutoff %d\n", pdbx_refine.free_R_val_test_set_ct_4sig_cutoff); 
   if(pdbx_refine.free_R_val_test_set_ct_no_cutoff >INI)
       fprintf(fout,"_pdbx_refine.free_R_val_test_set_ct_no_cutoff %d\n", pdbx_refine.free_R_val_test_set_ct_no_cutoff); 
   if(pdbx_refine.free_R_val_test_set_size_perc_4sig_cutoff >INI)
       fprintf(fout,"_pdbx_refine.free_R_val_test_set_size_perc_4sig_cutoff %.4f\n", pdbx_refine.free_R_val_test_set_size_perc_4sig_cutoff); 
   if(pdbx_refine.free_R_val_test_set_size_perc_no_cutoff >INI)
       fprintf(fout,"_pdbx_refine.free_R_val_test_set_size_perc_no_cutoff %.4f\n", pdbx_refine.free_R_val_test_set_size_perc_no_cutoff); 
   if(pdbx_refine.number_reflns_obs_4sig_cutoff >INI)
       fprintf(fout,"_pdbx_refine.number_reflns_obs_4sig_cutoff %d\n", pdbx_refine.number_reflns_obs_4sig_cutoff); 
   if(pdbx_refine.number_reflns_obs_no_cutoff >INI)
       fprintf(fout,"_pdbx_refine.number_reflns_obs_no_cutoff %d\n", pdbx_refine.number_reflns_obs_no_cutoff); 
   if(pdbx_refine.free_R_error_no_cutoff >INI)
       fprintf(fout,"_pdbx_refine.free_R_error_no_cutoff %.4f\n", pdbx_refine.free_R_error_no_cutoff); 

//   exit(0);
   

}


void write_refine_ls_shell(FILE *fout)
{

    if(refine_ls_shell.nbin<=0) return;
       
    fprintf(fout,"#\n");
    fprintf(fout,"loop_\n");
    fprintf(fout,"_refine_ls_shell.d_res_high\n");
    fprintf(fout,"_refine_ls_shell.d_res_low\n");
    fprintf(fout,"_refine_ls_shell.pdbx_total_number_of_bins_used\n");
    fprintf(fout,"_refine_ls_shell.percent_reflns_obs\n");
    fprintf(fout,"_refine_ls_shell.number_reflns_R_work\n");
    fprintf(fout,"_refine_ls_shell.R_factor_all\n");
    fprintf(fout,"_refine_ls_shell.R_factor_R_work\n");
    fprintf(fout,"_refine_ls_shell.R_factor_R_free\n");
    fprintf(fout,"_refine_ls_shell.percent_reflns_R_free\n");
    fprintf(fout,"_refine_ls_shell.number_reflns_R_free\n");
    fprintf(fout,"_refine_ls_shell.R_factor_R_free_error\n");
    fprintf(fout,"_refine_ls_shell.number_reflns_all\n");
    fprintf(fout,"_refine_ls_shell.number_reflns_obs\n");
    fprintf(fout,"_refine_ls_shell.pdbx_refine_id\n");

    if (refine_ls_shell.pdbx_refine_id[0] && strstr(refine_ls_shell.pdbx_refine_id[0], "X-RAY")) {
        write_refine_ls_shell_run(fout, refine_ls_shell);
    }
    
    if (refine_shell_neut.pdbx_refine_id[0] && strstr(refine_shell_neut.pdbx_refine_id[0], "NEUTRON")) {
        write_refine_ls_shell_run(fout, refine_shell_neut);
    }
    
}

void write_refine_ls_shell_run(FILE *fout, REFINE_LS_SHELL refine_ls_shell)
{
    
    int m=0;
    
    for(m=0; m<refine_ls_shell.nbin; m++){
    
        (refine_ls_shell.d_res_high[m] >-9998) ?
            fprintf(fout,"%.4f  ", refine_ls_shell.d_res_high[m]) : fprintf(fout,"?  ");
    
        (refine_ls_shell.d_res_low[m] > 0) ?
            fprintf(fout,"%.4f  ", refine_ls_shell.d_res_low[m]) : fprintf(fout,"?  ");
    
        (refine_ls_shell.pdbx_total_number_of_bins_used[m] > 0) ?
            fprintf(fout,"%d  ", refine_ls_shell.pdbx_total_number_of_bins_used[m]) : fprintf(fout,"?  ");
    
        (refine_ls_shell.percent_reflns_obs[m] > 0) ?
            fprintf(fout,"%.4f  ", refine_ls_shell.percent_reflns_obs[m]) : fprintf(fout,"?  ");
    
        (refine_ls_shell.number_reflns_R_work[m] > 0) ?
            fprintf(fout,"%d  ", refine_ls_shell.number_reflns_R_work[m]) : fprintf(fout,"?  ");
    
        (refine_ls_shell.R_factor_all[m] > 0) ?
            fprintf(fout,"%.4f  ", refine_ls_shell.R_factor_all[m]) : fprintf(fout,"?  ");
    
        (refine_ls_shell.R_factor_R_work[m] > 0) ?
            fprintf(fout,"%.4f  ", refine_ls_shell.R_factor_R_work[m]) : fprintf(fout,"?  ");
    
        (refine_ls_shell.R_factor_R_free[m] > 0) ?
            fprintf(fout,"%.4f  ", refine_ls_shell.R_factor_R_free[m]) : fprintf(fout,"?  ");
    
        (refine_ls_shell.percent_reflns_R_free[m] > 0) ?
            fprintf(fout,"%.4f  ", refine_ls_shell.percent_reflns_R_free[m]) : fprintf(fout,"?  ");
    
        (refine_ls_shell.number_reflns_R_free[m] > 0) ?
            fprintf(fout,"%d  ", refine_ls_shell.number_reflns_R_free[m]) : fprintf(fout,"?  ");
    
        (refine_ls_shell.R_factor_R_free_error[m] >= 0  ) ?
            fprintf(fout,"%.4f  ", refine_ls_shell.R_factor_R_free_error[m]) : fprintf(fout,"?  ");


        if(refine_ls_shell.number_reflns_R_work[m]>0 && refine_ls_shell.number_reflns_R_free[m]>0
           && refine_ls_shell.number_reflns_all[m]<=0){
            refine_ls_shell.number_reflns_all[m] = refine_ls_shell.number_reflns_R_work[m] +
                refine_ls_shell.number_reflns_R_free[m];
        }
        
        (refine_ls_shell.number_reflns_all[m] > 0  ) ?
            fprintf(fout,"%d  ", refine_ls_shell.number_reflns_all[m]) : fprintf(fout,"?  ");
        
        (refine_ls_shell.number_reflns_obs[m] > 0  ) ?
            fprintf(fout,"%d  ", refine_ls_shell.number_reflns_obs[m]) : fprintf(fout,"?  ");

        (refine_ls_shell.pdbx_refine_id[m] ) ?
            fprintf(fout,"'%s'  ", refine_ls_shell.pdbx_refine_id[m]) : fprintf(fout,"?  ");

        
        fprintf(fout,"\n");
        
    }

}

void write_reflns_shell(FILE *fout)
{

    if(reflns_shell.nbin<=0) return;
        
    fprintf(fout, "\n# statistics from LOG files (_reflns.shells)\n");
    fprintf(fout, "\nloop_\n");
    
    fprintf(fout, " _reflns_shell.pdbx_diffrn_id \n");
    fprintf(fout, " _reflns_shell.pdbx_ordinal \n");


    fprintf(fout, "_reflns_shell.d_res_high\n");
    fprintf(fout, "_reflns_shell.d_res_low\n");

    fprintf(fout, "_reflns_shell.number_measured_obs\n");
    fprintf(fout, "_reflns_shell.number_measured_all\n");
    fprintf(fout, "_reflns_shell.number_unique_obs \n");
    fprintf(fout, "_reflns_shell.pdbx_rejects\n");

    fprintf(fout, "_reflns_shell.Rmerge_I_obs\n");
    fprintf(fout, "_reflns_shell.meanI_over_sigI_obs \n");
    
    fprintf(fout, "_reflns_shell.pdbx_Rsym_value \n");
    fprintf(fout, "_reflns_shell.pdbx_chi_squared\n");
    fprintf(fout, "_reflns_shell.pdbx_redundancy\n");
    fprintf(fout, "_reflns_shell.percent_possible_obs\n");
    fprintf(fout, "_reflns_shell.pdbx_netI_over_sigmaI_obs \n");
        
    fprintf(fout, "_reflns_shell.number_possible\n");
    fprintf(fout, "_reflns_shell.number_unique_all\n");
   
    fprintf(fout, "_reflns_shell.Rmerge_F_all\n");
    fprintf(fout, "_reflns_shell.Rmerge_F_obs\n");
    fprintf(fout, "_reflns_shell.Rmerge_I_all\n");
    
    fprintf(fout, "_reflns_shell.meanI_over_sigI_all\n");
    fprintf(fout, "_reflns_shell.percent_possible_all\n");

    fprintf(fout, "_reflns_shell.pdbx_Rrim_I_all\n");
    fprintf(fout, "_reflns_shell.pdbx_Rpim_I_all\n");

    fprintf(fout, "_reflns_shell.pdbx_CC_half\n");
    
    fprintf(fout, "_reflns_shell.pdbx_number_anomalous \n");

//    fprintf(fout, "_reflns_shell.pdbx_meanI_over_sigI_anomalous \n");
//    fprintf(fout, "_reflns_shell.pdbx_Rmeas_mean \n");
//    fprintf(fout, "_reflns_shell.pdbx_netI_over_sigmaI_obs \n");
//    fprintf(fout, "_reflns_shell.pdbx_number_centric \n");
//    fprintf(fout, "_reflns_shell.pdbx_Rmerge_I_anomalous \n");
//    fprintf(fout, "_reflns_shell.pdbx_PCV_mean \n");

    if (reflns_shell.d_res_high>0) write_reflns_shell_run(fout, reflns_shell);
    if (reflns_shell_neut.d_res_high>0) write_reflns_shell_run(fout, reflns_shell_neut);
}

void  write_reflns_shell_run(FILE *fout, REFLNS_SHELL reflns_shell)
//The order of items must be the same as the cif order write_reflns_shell
{
    int m;
    
    
    for(m=0; m<reflns_shell.nbin; m++){
    
        fprintf(fout,"%s  %d ", reflns_shell.pdbx_diffrn_id[m],  m+1);
        (reflns_shell.d_res_high[m]>0) ?
            fprintf(fout," %.3f ", reflns_shell.d_res_high[m]) : fprintf(fout," ? ");
        
        (reflns_shell.d_res_low[m]>0) ?
            fprintf(fout," %.3f ", reflns_shell.d_res_low[m]) : fprintf(fout," ? ");


        (reflns_shell.number_measured_obs[m]>0) ?
            fprintf(fout," %d ", reflns_shell.number_measured_obs[m]): fprintf(fout," ? ");

        (reflns_shell.number_measured_all[m]>0) ?
            fprintf(fout," %d ", reflns_shell.number_measured_all[m]): fprintf(fout," ? ");
        
        (reflns_shell.number_unique_obs[m]>0) ?
            fprintf(fout," %d ",reflns_shell.number_unique_obs[m]): fprintf(fout," ? ");

        (reflns_shell.pdbx_rejects[m]>0) ?
            fprintf(fout," %d ", reflns_shell.pdbx_rejects[m]): fprintf(fout," ? ");


        (reflns_shell.Rmerge_I_obs[m]>0) ?
            fprintf(fout," %.3f ",reflns_shell.Rmerge_I_obs[m]): fprintf(fout," ? ");



        (reflns_shell.meanI_over_sigI_obs[m]>0) ?
            fprintf(fout," %.3f ", reflns_shell.meanI_over_sigI_obs[m]): fprintf(fout," ? ");
        
        (reflns_shell.pdbx_Rsym_value[m]>0) ?
            fprintf(fout," %.3f \n",reflns_shell.pdbx_Rsym_value[m]):fprintf(fout," ? ");
        (reflns_shell.pdbx_chi_squared[m]>0) ?
            fprintf(fout," %.3f ", reflns_shell.pdbx_chi_squared[m]): fprintf(fout," ? ");
        (reflns_shell.pdbx_redundancy[m]>0) ?
            fprintf(fout," %.3f ", reflns_shell.pdbx_redundancy[m]): fprintf(fout," ? ");
        
        (reflns_shell.percent_possible_obs[m]>0) ?
            fprintf(fout," %.3f ", reflns_shell.percent_possible_obs[m]): fprintf(fout," ? ");

        (reflns_shell.pdbx_netI_over_sigmaI_obs[m]>0) ?
            fprintf(fout," %.3f ", reflns_shell.pdbx_netI_over_sigmaI_obs[m]): fprintf(fout," ? ");

        
        (reflns_shell.number_possible[m]>0) ?
            fprintf(fout," %d ",reflns_shell.number_possible[m]): fprintf(fout," ? ");
        
        (reflns_shell.number_unique_all[m]>0) ?
            fprintf(fout," %d ", reflns_shell.number_unique_all[m]): fprintf(fout," ? ");


        
        (reflns_shell.Rmerge_F_all[m]>0) ?
            fprintf(fout," %.3f ",reflns_shell.Rmerge_F_all[m]): fprintf(fout," ? ");
        
        (reflns_shell.Rmerge_F_obs[m]>0) ?
            fprintf(fout," %.3f ",reflns_shell.Rmerge_F_obs[m]): fprintf(fout," ? ");
        
        (reflns_shell.Rmerge_I_all[m]>0) ?
            fprintf(fout," %.3f ",reflns_shell.Rmerge_I_all[m]): fprintf(fout," ? ");

        (reflns_shell.meanI_over_sigI_all[m]>0) ?
            fprintf(fout," %.3f ", reflns_shell.meanI_over_sigI_all[m]): fprintf(fout," ? ");
        

        (reflns_shell.percent_possible_all[m]>0) ?
            fprintf(fout," %.3f ", reflns_shell.percent_possible_all[m]): fprintf(fout," ? ");

        (reflns_shell.pdbx_Rrim_I_all[m]>0) ?
            fprintf(fout," %.3f ", reflns_shell.pdbx_Rrim_I_all[m]): fprintf(fout," ? ");
        (reflns_shell.pdbx_Rpim_I_all[m]>0) ?
            fprintf(fout," %.3f ", reflns_shell.pdbx_Rpim_I_all[m]): fprintf(fout," ? ");

        (reflns_shell.pdbx_CC_half[m]>0) ?
            fprintf(fout," %.3f ", reflns_shell.pdbx_CC_half[m]): fprintf(fout," ? ");

        (reflns_shell.pdbx_number_anomalous[m]>0) ?
            fprintf(fout," %d ",reflns_shell.pdbx_number_anomalous[m] ): fprintf(fout," ? ");

//        (reflns_shell.pdbx_meanI_over_sigI_anomalous[m]>0) ?
//            fprintf(fout," %.3f ",reflns_shell.pdbx_meanI_over_sigI_anomalous[m] ): fprintf(fout," ? ");


//        (reflns_shell.pdbx_Rmeas_mean[m]>0) ?
//            fprintf(fout," %.3f ", reflns_shell.pdbx_Rmeas_mean[m]): fprintf(fout," ? ");

        
//        (reflns_shell.pdbx_number_centric[m]>0) ?
//            fprintf(fout," %d ", reflns_shell.pdbx_number_centric[m]): fprintf(fout," ? ");


//        (reflns_shell.pdbx_Rmerge_I_anomalous[m]>0) ?
//            fprintf(fout," %.3f ",reflns_shell.pdbx_Rmerge_I_anomalous[m] ): fprintf(fout," ? ");


//        (reflns_shell.pdbx_PCV_mean[m]>0) ?
//            fprintf(fout," %.3f ",reflns_shell.pdbx_PCV_mean[m] ): fprintf(fout," ? ");


        fprintf(fout," \n");
        
    }
    
}
void write_reflns(FILE *fout){
    if (reflns.pdbx_diffrn_id[0]=='?' && !reflns_neut.pdbx_diffrn_id ) return;

    fprintf(fout,"#\n");
    fprintf(fout,"loop_ \n \
_reflns.entry_id \n \
_reflns.pdbx_diffrn_id \n \
_reflns.pdbx_ordinal \n \
_reflns.observed_criterion_sigma_I \n \
_reflns.observed_criterion_sigma_F \n \
_reflns.d_resolution_low \n \
_reflns.d_resolution_high \n \
_reflns.number_obs \n \
_reflns.number_all \n \
_reflns.percent_possible_obs \n \
_reflns.pdbx_Rmerge_I_obs \n \
_reflns.pdbx_Rsym_value \n \
_reflns.pdbx_netI_over_sigmaI \n \
_reflns.B_iso_Wilson_estimate \n \
_reflns.pdbx_redundancy \n \
_reflns.pdbx_Rrim_I_all \n \
_reflns.pdbx_Rpim_I_all \n \
_reflns.pdbx_CC_half \n \
_reflns.pdbx_netI_over_av_sigmaI \n \
_reflns.pdbx_number_measured_all \n \
_reflns.pdbx_scaling_rejects \n \
_reflns.pdbx_chi_squared \n \
_reflns.Rmerge_F_all \n \
_reflns.Rmerge_F_obs \n \
_reflns.observed_criterion_F_max \n \
_reflns.observed_criterion_F_min \n \
_reflns.observed_criterion_I_max \n \
_reflns.observed_criterion_I_min \n \
_reflns.pdbx_d_res_high_opt \n \
_reflns.pdbx_d_res_low_opt  \n \
_reflns.details \n \
");
    if (reflns.pdbx_diffrn_id) write_reflns_run(fout, reflns);
    if (reflns_neut.pdbx_diffrn_id) write_reflns_run(fout, reflns_neut);
}

void write_reflns_run(FILE *fout, REFLNS reflns){
fprintf(fout," '%s' ", DATA_BLOCK);
(reflns.pdbx_diffrn_id) ? fprintf(fout," '%s' ",reflns.pdbx_diffrn_id) : fprintf(fout," 1 ");
(reflns.pdbx_ordinal) ? fprintf(fout," '%s'  ",reflns.pdbx_ordinal) : fprintf(fout," ? ");
(reflns.observed_criterion_sigma_I>0) ? fprintf(fout," %.3f  ",reflns.observed_criterion_sigma_I) : fprintf(fout," ? ");
(reflns.observed_criterion_sigma_F>0) ? fprintf(fout," %.3f  ",reflns.observed_criterion_sigma_F) : fprintf(fout," ? ");
(reflns.d_resolution_low>0) ? fprintf(fout," %.3f  ",reflns.d_resolution_low) : fprintf(fout," ? ");
(reflns.d_resolution_high>0) ? fprintf(fout," %.3f  ",reflns.d_resolution_high) : fprintf(fout," ? ");
(reflns.number_obs>0) ? fprintf(fout," %d  ",reflns.number_obs) : fprintf(fout," ? ");
(reflns.number_all>0) ? fprintf(fout," %d  ",reflns.number_all) : fprintf(fout," ? ");
(reflns.percent_possible_obs>0) ? fprintf(fout," %.3f  ",reflns.percent_possible_obs) : fprintf(fout," ? ");
(reflns.pdbx_Rmerge_I_obs>0) ? fprintf(fout," %.3f  ",reflns.pdbx_Rmerge_I_obs) : fprintf(fout," ? ");
(reflns.pdbx_Rsym_value>0) ? fprintf(fout," %.3f  ",reflns.pdbx_Rsym_value) : fprintf(fout," ? ");
(reflns.pdbx_netI_over_sigmaI>0) ? fprintf(fout," %.3f  ",reflns.pdbx_netI_over_sigmaI) : fprintf(fout," ? ");
(reflns.B_iso_Wilson_estimate>0) ? fprintf(fout," %.3f  ",reflns.B_iso_Wilson_estimate) : fprintf(fout," ? ");
(reflns.pdbx_redundancy>0) ? fprintf(fout," %.3f  ",reflns.pdbx_redundancy) : fprintf(fout," ? ");
(reflns.pdbx_Rrim_I_all>0) ? fprintf(fout," %.3f  ",reflns.pdbx_Rrim_I_all) : fprintf(fout," ? ");
(reflns.pdbx_Rpim_I_all>0) ? fprintf(fout," %.3f  ",reflns.pdbx_Rpim_I_all) : fprintf(fout," ? ");
(reflns.pdbx_CC_half>0) ? fprintf(fout," %.3f  ",reflns.pdbx_CC_half) : fprintf(fout," ? ");
(reflns.pdbx_netI_over_av_sigmaI>0) ? fprintf(fout," %.3f  ",reflns.pdbx_netI_over_av_sigmaI) : fprintf(fout," ? ");
(reflns.pdbx_number_measured_all>0) ? fprintf(fout," %d  ",reflns.pdbx_number_measured_all) : fprintf(fout," ? ");
(reflns.pdbx_scaling_rejects>0) ? fprintf(fout," %d  ",reflns.pdbx_scaling_rejects) : fprintf(fout," ? ");
(reflns.pdbx_chi_squared>0) ? fprintf(fout," %.3f  ",reflns.pdbx_chi_squared) : fprintf(fout," ? ");
(reflns.Rmerge_F_all>0) ? fprintf(fout," %.3f  ",reflns.Rmerge_F_all) : fprintf(fout," ? ");
(reflns.Rmerge_F_obs>0) ? fprintf(fout," %.3f  ",reflns.Rmerge_F_obs) : fprintf(fout," ? ");
(reflns.observed_criterion_F_max>0) ? fprintf(fout," %.3f  ",reflns.observed_criterion_F_max) : fprintf(fout," ? ");
(reflns.observed_criterion_F_min>0) ? fprintf(fout," %.3f  ",reflns.observed_criterion_F_min) : fprintf(fout," ? ");
(reflns.observed_criterion_I_max>0) ? fprintf(fout," %.3f  ",reflns.observed_criterion_I_max) : fprintf(fout," ? ");
(reflns.observed_criterion_I_min>0) ? fprintf(fout," %.3f  ",reflns.observed_criterion_I_min) : fprintf(fout," ? ");

(reflns.pdbx_d_res_high_opt>0) ? fprintf(fout," %.3f  ",reflns.pdbx_d_res_high_opt) : fprintf(fout," ? ");
(reflns.pdbx_d_res_low_opt>0) ? fprintf(fout," %.3f  ",reflns.pdbx_d_res_low_opt) : fprintf(fout," ? ");
(reflns.details) ? fprintf(fout," %s  ",reflns.details) : fprintf(fout," ? ");

fprintf(fout," \n");

}
